<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.11"/>
<title>eRPC Generator (erpcgen): Annotation.h Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<script type="text/javascript">
  $(document).ready(initResizable);
  $(window).load(resizeHeight);
</script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<script type="text/javascript">
  $(document).ready(function() { init_search(); });
</script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
<link href="customdoxygen.css" rel="stylesheet" type="text/css"/>
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">eRPC Generator (erpcgen)
   &#160;<span id="projectnumber">Rev. 1.4.0</span>
   </div>
   <div id="projectbrief">NXP Semiconductors</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.11 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Search');
</script>
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li>
        <div id="MSearchBox" class="MSearchBoxInactive">
        <span class="left">
          <img id="MSearchSelect" src="search/mag_sel.png"
               onmouseover="return searchBox.OnSearchSelectShow()"
               onmouseout="return searchBox.OnSearchSelectHide()"
               alt=""/>
          <input type="text" id="MSearchField" value="Search" accesskey="S"
               onfocus="searchBox.OnSearchFieldFocus(true)" 
               onblur="searchBox.OnSearchFieldFocus(false)" 
               onkeyup="searchBox.OnSearchFieldChange(event)"/>
          </span><span class="right">
            <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0" src="search/close.png" alt=""/></a>
          </span>
        </div>
      </li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
    </ul>
  </div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
$(document).ready(function(){initNavTree('_annotation_8h_source.html','');});
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="headertitle">
<div class="title">Annotation.h</div>  </div>
</div><!--header-->
<div class="contents">
<div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="comment">/*</span></div><div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="comment"> * Copyright (c) 2014, Freescale Semiconductor, Inc.</span></div><div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="comment"> * Copyright 2016 NXP</span></div><div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="comment"> * All rights reserved.</span></div><div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160;<span class="comment"> *</span></div><div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="comment"> * Redistribution and use in source and binary forms, with or without modification,</span></div><div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;<span class="comment"> * are permitted provided that the following conditions are met:</span></div><div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;<span class="comment"> *</span></div><div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;<span class="comment"> * o Redistributions of source code must retain the above copyright notice, this list</span></div><div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;<span class="comment"> *   of conditions and the following disclaimer.</span></div><div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;<span class="comment"> *</span></div><div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;<span class="comment"> * o Redistributions in binary form must reproduce the above copyright notice, this</span></div><div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;<span class="comment"> *   list of conditions and the following disclaimer in the documentation and/or</span></div><div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;<span class="comment"> *   other materials provided with the distribution.</span></div><div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;<span class="comment"> *</span></div><div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;<span class="comment"> * o Neither the name of the copyright holder nor the names of its</span></div><div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;<span class="comment"> *   contributors may be used to endorse or promote products derived from this</span></div><div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;<span class="comment"> *   software without specific prior written permission.</span></div><div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;<span class="comment"> *</span></div><div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;<span class="comment"> * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS &quot;AS IS&quot; AND</span></div><div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;<span class="comment"> * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED</span></div><div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;<span class="comment"> * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE</span></div><div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;<span class="comment"> * DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR</span></div><div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;<span class="comment"> * ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES</span></div><div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;<span class="comment"> * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;</span></div><div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;<span class="comment"> * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON</span></div><div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;<span class="comment"> * ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT</span></div><div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;<span class="comment"> * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS</span></div><div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;<span class="comment"> * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.</span></div><div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;<span class="comment"> */</span></div><div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160;</div><div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160;<span class="preprocessor">#ifndef _EMBEDDED_RPC__ANNOTATION_H_</span></div><div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160;<span class="preprocessor">#define _EMBEDDED_RPC__ANNOTATION_H_</span></div><div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;</div><div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;<span class="preprocessor">#include &quot;AstNode.h&quot;</span></div><div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160;<span class="preprocessor">#include &quot;Token.h&quot;</span></div><div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;<span class="preprocessor">#include &quot;Value.h&quot;</span></div><div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160;<span class="preprocessor">#include &lt;string&gt;</span></div><div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160;</div><div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160;<span class="comment">// Classes</span></div><div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160;<span class="comment"></span></div><div class="line"><a name="l00044"></a><span class="lineno">   44</span>&#160;<span class="keyword">namespace </span><a class="code" href="namespaceerpcgen.html">erpcgen</a> {</div><div class="line"><a name="l00045"></a><span class="lineno">   45</span>&#160;</div><div class="line"><a name="l00049"></a><span class="lineno"><a class="line" href="classerpcgen_1_1_annotation.html">   49</a></span>&#160;<span class="keyword">class </span><a class="code" href="classerpcgen_1_1_annotation.html">Annotation</a></div><div class="line"><a name="l00050"></a><span class="lineno">   50</span>&#160;{</div><div class="line"><a name="l00051"></a><span class="lineno">   51</span>&#160;<span class="keyword">public</span>:</div><div class="line"><a name="l00060"></a><span class="lineno"><a class="line" href="classerpcgen_1_1_annotation.html#ab798a293e491bf62c2f54e8c8ec53dac">   60</a></span>&#160;    <a class="code" href="classerpcgen_1_1_annotation.html#ab798a293e491bf62c2f54e8c8ec53dac">Annotation</a>(<span class="keyword">const</span> <a class="code" href="classerpcgen_1_1_token.html">Token</a> &amp;token, <a class="code" href="class_value.html">Value</a> *val)</div><div class="line"><a name="l00061"></a><span class="lineno">   61</span>&#160;    : m_name(token.getStringValue())</div><div class="line"><a name="l00062"></a><span class="lineno">   62</span>&#160;    , m_value(val)</div><div class="line"><a name="l00063"></a><span class="lineno">   63</span>&#160;    , m_location(token.<a class="code" href="classerpcgen_1_1_annotation.html#aef0bc8ff519273c631b0b79213650e0b">getLocation</a>())</div><div class="line"><a name="l00064"></a><span class="lineno">   64</span>&#160;    {</div><div class="line"><a name="l00065"></a><span class="lineno">   65</span>&#160;    }</div><div class="line"><a name="l00066"></a><span class="lineno">   66</span>&#160;</div><div class="line"><a name="l00074"></a><span class="lineno"><a class="line" href="classerpcgen_1_1_annotation.html#aeaa03b81e72b64279bf91374761b7363">   74</a></span>&#160;    <a class="code" href="classerpcgen_1_1_annotation.html#aeaa03b81e72b64279bf91374761b7363">Annotation</a>(<span class="keyword">const</span> <a class="code" href="classerpcgen_1_1_token.html">Token</a> &amp;token)</div><div class="line"><a name="l00075"></a><span class="lineno">   75</span>&#160;    : m_name(token.getStringValue())</div><div class="line"><a name="l00076"></a><span class="lineno">   76</span>&#160;    , m_value(nullptr)</div><div class="line"><a name="l00077"></a><span class="lineno">   77</span>&#160;    , m_location(token.<a class="code" href="classerpcgen_1_1_annotation.html#aef0bc8ff519273c631b0b79213650e0b">getLocation</a>())</div><div class="line"><a name="l00078"></a><span class="lineno">   78</span>&#160;    {</div><div class="line"><a name="l00079"></a><span class="lineno">   79</span>&#160;    }</div><div class="line"><a name="l00080"></a><span class="lineno">   80</span>&#160;</div><div class="line"><a name="l00088"></a><span class="lineno"><a class="line" href="classerpcgen_1_1_annotation.html#ad5599315f40334388f52cbb55c21f615">   88</a></span>&#160;    <a class="code" href="classerpcgen_1_1_annotation.html#ad5599315f40334388f52cbb55c21f615">Annotation</a>(<span class="keyword">const</span> <a class="code" href="classerpcgen_1_1_annotation.html">Annotation</a> &amp;a)</div><div class="line"><a name="l00089"></a><span class="lineno">   89</span>&#160;    : m_name(a.m_name)</div><div class="line"><a name="l00090"></a><span class="lineno">   90</span>&#160;    , m_value(a.m_value)</div><div class="line"><a name="l00091"></a><span class="lineno">   91</span>&#160;    , m_location(a.m_location)</div><div class="line"><a name="l00092"></a><span class="lineno">   92</span>&#160;    {</div><div class="line"><a name="l00093"></a><span class="lineno">   93</span>&#160;    }</div><div class="line"><a name="l00094"></a><span class="lineno">   94</span>&#160;</div><div class="line"><a name="l00100"></a><span class="lineno"><a class="line" href="classerpcgen_1_1_annotation.html#ac6d4173cec7d8af927ce985be66a3c17">  100</a></span>&#160;    std::string <a class="code" href="classerpcgen_1_1_annotation.html#ac6d4173cec7d8af927ce985be66a3c17">getName</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> m_name; }</div><div class="line"><a name="l00101"></a><span class="lineno">  101</span>&#160;</div><div class="line"><a name="l00107"></a><span class="lineno"><a class="line" href="classerpcgen_1_1_annotation.html#ac72c8edb29ff6c07ff611151cb57a5f0">  107</a></span>&#160;    <span class="keywordtype">bool</span> <a class="code" href="classerpcgen_1_1_annotation.html#ac72c8edb29ff6c07ff611151cb57a5f0">hasValue</a>() { <span class="keywordflow">return</span> <span class="keyword">nullptr</span> != m_value; }</div><div class="line"><a name="l00108"></a><span class="lineno">  108</span>&#160;</div><div class="line"><a name="l00116"></a><span class="lineno">  116</span>&#160;    <a class="code" href="class_value.html">Value</a> *<a class="code" href="classerpcgen_1_1_annotation.html#ac907c227156887ae849bb1ae64989dd5">getValueObject</a>();</div><div class="line"><a name="l00117"></a><span class="lineno">  117</span>&#160;</div><div class="line"><a name="l00123"></a><span class="lineno"><a class="line" href="classerpcgen_1_1_annotation.html#a78189821380af354ecde579745673b4d">  123</a></span>&#160;    std::string <a class="code" href="classerpcgen_1_1_annotation.html#a78189821380af354ecde579745673b4d">toString</a>() { <span class="keywordflow">return</span> m_name + <span class="stringliteral">&quot; = &quot;</span> + m_value-&gt;toString(); }</div><div class="line"><a name="l00124"></a><span class="lineno">  124</span>&#160;</div><div class="line"><a name="l00130"></a><span class="lineno"><a class="line" href="classerpcgen_1_1_annotation.html#aef0bc8ff519273c631b0b79213650e0b">  130</a></span>&#160;    <a class="code" href="structerpcgen_1_1token__loc__t.html">token_loc_t</a> &amp;<a class="code" href="classerpcgen_1_1_annotation.html#aef0bc8ff519273c631b0b79213650e0b">getLocation</a>() { <span class="keywordflow">return</span> m_location; }</div><div class="line"><a name="l00131"></a><span class="lineno">  131</span>&#160;</div><div class="line"><a name="l00132"></a><span class="lineno">  132</span>&#160;<span class="keyword">private</span>:</div><div class="line"><a name="l00133"></a><span class="lineno">  133</span>&#160;    std::string m_name;     </div><div class="line"><a name="l00134"></a><span class="lineno">  134</span>&#160;    <a class="code" href="class_value.html">Value</a> *m_value;         </div><div class="line"><a name="l00135"></a><span class="lineno">  135</span>&#160;    <a class="code" href="structerpcgen_1_1token__loc__t.html">token_loc_t</a> m_location; </div><div class="line"><a name="l00136"></a><span class="lineno">  136</span>&#160;};</div><div class="line"><a name="l00137"></a><span class="lineno">  137</span>&#160;</div><div class="line"><a name="l00138"></a><span class="lineno">  138</span>&#160;} <span class="comment">// namespace erpcgen</span></div><div class="line"><a name="l00139"></a><span class="lineno">  139</span>&#160;</div><div class="line"><a name="l00140"></a><span class="lineno">  140</span>&#160;<span class="preprocessor">#endif // _EMBEDDED_RPC__ANNOTATION_H_</span></div><div class="ttc" id="classerpcgen_1_1_annotation_html"><div class="ttname"><a href="classerpcgen_1_1_annotation.html">erpcgen::Annotation</a></div><div class="ttdoc">Annotation class. </div><div class="ttdef"><b>Definition:</b> Annotation.h:49</div></div>
<div class="ttc" id="classerpcgen_1_1_annotation_html_ad5599315f40334388f52cbb55c21f615"><div class="ttname"><a href="classerpcgen_1_1_annotation.html#ad5599315f40334388f52cbb55c21f615">erpcgen::Annotation::Annotation</a></div><div class="ttdeci">Annotation(const Annotation &amp;a)</div><div class="ttdoc">Constructor. </div><div class="ttdef"><b>Definition:</b> Annotation.h:88</div></div>
<div class="ttc" id="classerpcgen_1_1_annotation_html_a78189821380af354ecde579745673b4d"><div class="ttname"><a href="classerpcgen_1_1_annotation.html#a78189821380af354ecde579745673b4d">erpcgen::Annotation::toString</a></div><div class="ttdeci">std::string toString()</div><div class="ttdoc">This function returns toString representation. </div><div class="ttdef"><b>Definition:</b> Annotation.h:123</div></div>
<div class="ttc" id="classerpcgen_1_1_annotation_html_ac72c8edb29ff6c07ff611151cb57a5f0"><div class="ttname"><a href="classerpcgen_1_1_annotation.html#ac72c8edb29ff6c07ff611151cb57a5f0">erpcgen::Annotation::hasValue</a></div><div class="ttdeci">bool hasValue()</div><div class="ttdoc">Checks to see if value instance member is null. </div><div class="ttdef"><b>Definition:</b> Annotation.h:107</div></div>
<div class="ttc" id="class_value_html"><div class="ttname"><a href="class_value.html">Value</a></div><div class="ttdoc">Abstract base class for values of arbitrary types. </div><div class="ttdef"><b>Definition:</b> Value.h:49</div></div>
<div class="ttc" id="classerpcgen_1_1_annotation_html_ab798a293e491bf62c2f54e8c8ec53dac"><div class="ttname"><a href="classerpcgen_1_1_annotation.html#ab798a293e491bf62c2f54e8c8ec53dac">erpcgen::Annotation::Annotation</a></div><div class="ttdeci">Annotation(const Token &amp;token, Value *val)</div><div class="ttdoc">Constructor. </div><div class="ttdef"><b>Definition:</b> Annotation.h:60</div></div>
<div class="ttc" id="classerpcgen_1_1_token_html"><div class="ttname"><a href="classerpcgen_1_1_token.html">erpcgen::Token</a></div><div class="ttdoc">Encapsulates all information about a token. </div><div class="ttdef"><b>Definition:</b> Token.h:69</div></div>
<div class="ttc" id="classerpcgen_1_1_annotation_html_ac6d4173cec7d8af927ce985be66a3c17"><div class="ttname"><a href="classerpcgen_1_1_annotation.html#ac6d4173cec7d8af927ce985be66a3c17">erpcgen::Annotation::getName</a></div><div class="ttdeci">std::string getName() const </div><div class="ttdoc">This function returns annotation name. </div><div class="ttdef"><b>Definition:</b> Annotation.h:100</div></div>
<div class="ttc" id="classerpcgen_1_1_annotation_html_aef0bc8ff519273c631b0b79213650e0b"><div class="ttname"><a href="classerpcgen_1_1_annotation.html#aef0bc8ff519273c631b0b79213650e0b">erpcgen::Annotation::getLocation</a></div><div class="ttdeci">token_loc_t &amp; getLocation()</div><div class="ttdoc">This function returns location for symbol. </div><div class="ttdef"><b>Definition:</b> Annotation.h:130</div></div>
<div class="ttc" id="structerpcgen_1_1token__loc__t_html"><div class="ttname"><a href="structerpcgen_1_1token__loc__t.html">erpcgen::token_loc_t</a></div><div class="ttdoc">Token location in the source file. </div><div class="ttdef"><b>Definition:</b> Token.h:47</div></div>
<div class="ttc" id="classerpcgen_1_1_annotation_html_aeaa03b81e72b64279bf91374761b7363"><div class="ttname"><a href="classerpcgen_1_1_annotation.html#aeaa03b81e72b64279bf91374761b7363">erpcgen::Annotation::Annotation</a></div><div class="ttdeci">Annotation(const Token &amp;token)</div><div class="ttdoc">Constructor. </div><div class="ttdef"><b>Definition:</b> Annotation.h:74</div></div>
<div class="ttc" id="classerpcgen_1_1_annotation_html_ac907c227156887ae849bb1ae64989dd5"><div class="ttname"><a href="classerpcgen_1_1_annotation.html#ac907c227156887ae849bb1ae64989dd5">erpcgen::Annotation::getValueObject</a></div><div class="ttdeci">Value * getValueObject()</div><div class="ttdoc">This function returns annotation value. </div><div class="ttdef"><b>Definition:</b> Type.cpp:65</div></div>
<div class="ttc" id="namespaceerpcgen_html"><div class="ttname"><a href="namespaceerpcgen.html">erpcgen</a></div><div class="ttdef"><b>Definition:</b> AstNode.h:47</div></div>
</div><!-- fragment --></div><!-- contents -->
</div><!-- doc-content -->
<!-- HTML footer for doxygen 1.8.5-->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul class="foot">
    <li class="footer">&copy; 2016 NXP Semiconductors. All rights reserved.
    </li>
  </ul>
</div>
</body>
</html>
